import { openBlock as p, createElementBlock as h, renderSlot as I, withDirectives as T, createElementVNode as c, normalizeStyle as v, toDisplayString as f, Fragment as E, renderList as x, vShow as y } from "vue";
const C = (t, e) => {
  const o = t.__vccOpts || t;
  for (const [i, s] of e)
    o[i] = s;
  return o;
}, N = {
  name: "IPHighlighter",
  props: {
    // API 基础URL
    apiUrl: {
      type: String,
      default: "https://cmdb.google.com/api/v2/get_env_by_ip"
    },
    // 自定义请求配置
    requestConfig: {
      type: Object,
      default: () => ({
        credentials: "include",
        headers: {
          Accept: "application/json",
          "Content-Type": "application/json"
        }
      })
    }
  },
  data() {
    return {
      showTooltip: !1,
      currentIP: null,
      ipInfo: null,
      tooltipStyle: {
        left: "0px",
        top: "0px"
      },
      // IP地址正则表达式
      ipRegex: /\b(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b/g
    };
  },
  mounted() {
    this.highlightIPs(), this.observeDOMChanges(), document.addEventListener("click", this.handleClickOutside);
  },
  beforeDestroy() {
    document.removeEventListener("click", this.handleClickOutside);
  },
  methods: {
    highlightIPs() {
      const t = this.$el, e = document.createTreeWalker(
        t,
        NodeFilter.SHOW_TEXT,
        {
          acceptNode: (i) => i.parentElement && ["SCRIPT", "STYLE", "TEXTAREA", "INPUT"].includes(i.parentElement.tagName) ? NodeFilter.FILTER_REJECT : i.textContent.match(this.ipRegex) ? NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_REJECT
        }
      ), o = [];
      for (; e.nextNode(); )
        o.push(e.currentNode);
      o.forEach((i) => {
        const s = i.parentNode, r = i.textContent, l = document.createDocumentFragment();
        let n = 0;
        const _ = r.matchAll(this.ipRegex);
        for (const g of _) {
          const d = g[0], u = g.index;
          u > n && l.appendChild(document.createTextNode(r.slice(n, u)));
          const a = document.createElement("span");
          a.className = "ip-highlight", a.textContent = d, a.addEventListener("mouseenter", (m) => this.showIPInfo(d, m)), a.addEventListener("mouseleave", this.handleMouseLeave), l.appendChild(a), n = u + d.length;
        }
        n < r.length && l.appendChild(document.createTextNode(r.slice(n))), s.replaceChild(l, i);
      });
    },
    async showIPInfo(t, e) {
      this.currentIP = t, this.ipInfo = null, this.updateTooltipPosition(e), this.showTooltip = !0;
      try {
        const i = await (await fetch(`${this.apiUrl}?ip=${t}`, this.requestConfig)).json();
        this.ipInfo = i;
      } catch (o) {
        console.error("获取IP信息失败:", o), this.ipInfo = { error: "获取信息失败" };
      }
    },
    updateTooltipPosition(t) {
      this.tooltipStyle = {
        left: `${t.pageX + 10}px`,
        top: `${t.pageY + 10}px`
      };
    },
    handleMouseLeave(t) {
      var o;
      const e = t.relatedTarget;
      (o = this.$refs.tooltip) != null && o.contains(e) || (this.showTooltip = !1);
    },
    handleClickOutside(t) {
      var e;
      !((e = this.$refs.tooltip) != null && e.contains(t.target)) && !t.target.classList.contains("ip-highlight") && (this.showTooltip = !1);
    },
    formatValue(t) {
      return t == null ? "N/A" : typeof t == "object" ? Array.isArray(t) ? t.join(", ") || "N/A" : Object.entries(t).map(([e, o]) => `${e}: ${this.formatValue(o)}`).join(", ") || "N/A" : String(t);
    },
    observeDOMChanges() {
      new MutationObserver((e) => {
        e.forEach((o) => {
          o.addedNodes.length && this.highlightIPs();
        });
      }).observe(this.$el, {
        childList: !0,
        subtree: !0
      });
    }
  }
}, P = { class: "ip-highlighter" }, b = { class: "ip-tooltip-header" }, w = { class: "ip-tooltip-title" }, k = { class: "ip-tooltip-content" }, L = { class: "ip-tooltip-key" }, S = { class: "ip-tooltip-value" }, A = {
  key: 1,
  class: "ip-tooltip-row"
};
function O(t, e, o, i, s, r) {
  return p(), h("div", P, [
    I(t.$slots, "default", {}, void 0, !0),
    T(c("div", {
      class: "ip-tooltip",
      style: v(s.tooltipStyle),
      ref: "tooltip"
    }, [
      c("div", b, [
        c("h3", w, "IP: " + f(s.currentIP), 1)
      ]),
      c("div", k, [
        s.ipInfo ? (p(!0), h(E, { key: 0 }, x(s.ipInfo, (l, n) => (p(), h("div", {
          key: n,
          class: "ip-tooltip-row"
        }, [
          c("div", L, f(n) + ":", 1),
          c("div", S, f(r.formatValue(l)), 1)
        ]))), 128)) : (p(), h("div", A, "加载中..."))
      ])
    ], 4), [
      [y, s.showTooltip]
    ])
  ]);
}
const R = /* @__PURE__ */ C(N, [["render", O], ["__scopeId", "data-v-bedda146"]]), $ = {
  install: (t) => {
    t.component("IPHighlighter", R);
  }
};
export {
  R as IPHighlighter,
  $ as default
};
